#ifndef PKCS11_UTILS_H
#define PKCS11_UTILS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dlfcn.h>
#include "./pkcs11/cryptoki.h"

void print_key_hex(CK_BYTE_PTR key_data, CK_ULONG key_len);
void* load_pkcs11_library(const char* library_path);
CK_RV get_function_list(void* pkcs11_library, CK_FUNCTION_LIST_PTR* function_list);
CK_RV initialize_pkcs11(CK_FUNCTION_LIST_PTR function_list);
CK_RV finalize_pkcs11(CK_FUNCTION_LIST_PTR function_list);
CK_RV get_slots(CK_FUNCTION_LIST_PTR function_list, CK_SLOT_ID* slots, CK_ULONG* slot_count);
CK_RV open_session(CK_FUNCTION_LIST_PTR function_list, CK_SLOT_ID slot_id, CK_SESSION_HANDLE* session);
CK_RV close_session(CK_FUNCTION_LIST_PTR function_list, CK_SESSION_HANDLE session);
CK_RV login(CK_FUNCTION_LIST_PTR function_list, CK_SESSION_HANDLE session, CK_USER_TYPE user_type, const char* pin);
CK_RV logout(CK_FUNCTION_LIST_PTR function_list, CK_SESSION_HANDLE session);
CK_BBOOL is_label_in_use(CK_FUNCTION_LIST_PTR function_list, CK_SESSION_HANDLE session, 
                        const char* key_label, CK_OBJECT_CLASS key_class,CK_KEY_TYPE key_type, CK_BBOOL tkn);
                        
CK_RV find_key_by_label(CK_FUNCTION_LIST_PTR function_list, CK_SESSION_HANDLE session,
                        const char* key_label, CK_OBJECT_CLASS key_class, 
                        CK_OBJECT_HANDLE_PTR key_handle,
                        CK_KEY_TYPE key_type, 
                        CK_BBOOL tkn);

#endif // PKCS11_UTILS_H
